	program main
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
      integer, parameter :: niter = 100000
      integer, parameter :: niter1 = 20000

      integer id
	real*8 bweight, bpd, mad, fl, ga
	real*8 smoke, sga, age, bmi
	real*8 x(nc), u(nr), tstar(3)

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk)
      real*8 vv, omega(nu,nu)
      
      real*8 bw(ni), zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta, v1, api
                 
      real*8 sigma_betaa, sigma_theta
      real*8 d0, s0, d1, s1, a0, b0
      real*8 sigma_gammaa, sigma_alpha, sigma_delta
      real*8 a1, b1
      real*8 temp, ttemp
     
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vvv/vv          
      common /vomega/omega     
      
      common /vbw/bw
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta
      common /vv1/v1
      
      common /vsigma_betaa/sigma_betaa
      common /vsigma_theta/sigma_theta
      common /vd0/d0
      common /vs0/s0
      common /vd1/d1
      common /vs1/s1
      common /va0/a0
      common /vb0/b0     

      common /vsigma_gammaa/sigma_gammaa
      common /vsigma_alpha/sigma_alpha
      common /vsigma_delta/sigma_delta
      common /va1/a1
      common /vb1/b1
                                
    	open(unit = 5, file = 'NewScan1.txt')
    	open(unit = 6, file = 'FetalGrowth_Initial.txt')
    	
    	open(unit = 11, file = 'FFetalGrowth_Output1.txt')
    	open(unit = 12, file = 'FFetalGrowth_Output2.txt')
    	open(unit = 13, file = 'FFetalGrowth_Output3.txt')
    	open(unit = 14, file = 'FFetalGrowth_Output4.txt')
    	open(unit = 15, file = 'FFetalGrowth_Output5.txt')
    	open(unit = 16, file = 'FFetalGrowth_Output6.txt')
    	open(unit = 17, file = 'FFetalGrowth_Output7.txt')
            
      iseed = 9999999

      do i = 1, ni
        do j = 1, nj
            do k = 1, nk
                y(i,j,k) = -999.d0
                do l = 1, nx 
                    xstar(i,j,k,l) = -999.d0
                enddo
                do l = 1, nu
                    ustar(i,j,k,l) = -999.d0
                enddo                   
            enddo
        enddo
      enddo
                 	           	
      tstar(1) = 18.85714d0/40.14285714d0
      tstar(2) = 26.14286d0/40.14285714d0
      tstar(3) = 33.71429d0/40.14285714d0 

	do ii = 1, 3189
	
	  read(5,*) i, j, bweight,  
     +            bpd, mad, fl, ga, 
     +            smoke, sga, age, bmi

        smoke = (smoke - 6.786199d0)/7.152488d0
        sga = (sga - 0.2409502d0)/0.4279023d0
        age = (age - 28.32579d0)/4.255989d0
        bmi = (bmi - 21.5142d0)/3.170548d0
                             
        if (bweight .gt. 4000.d0) then
            bw(i) = 1.d0
        else
            bw(i) = 0.d0
        endif

        ga = ga/40.14285714d0
                       
        y(i,j,1) = bpd
        y(i,j,2) = mad
        y(i,j,3) = fl

        u(1) = 1.d0 
        u(2) = ga 
        u(3) = ga**2 
        u(4) = ga**3
        do jj = 1, 3
	      temp = ga - tstar(jj)
	      if (temp .lt. 0.d0) then
	          temp = 0.d0
	      endif
	      u(jj+4) = temp**3
	  enddo
                         
        do jj = 1, nr
            x(jj) = u(jj)
        enddo
        x(nr+1) = age   
        x(nr+2) = bmi
        x(nr+3) = sga 
        x(nr+4) = smoke 
                      
        do k = 1, nk
            
            do l = 1, nx 
                xstar(i,j,k,l) = 0.d0
            enddo
            do l = 1, nc
                xstar(i,j,k,nc*(k-1)+l) = x(l)
            enddo
                
            do l = 1, nu
                ustar(i,j,k,l) = 0.d0
            enddo                   
            do l = 1, nr
                ustar(i,j,k,nr*(k-1)+l) = u(l)
            enddo                                
      
        enddo      
                       
        zstar(i,1) = 1.d0 
        zstar(i,2) = age   
        zstar(i,3) = bmi
        zstar(i,4) = sga 
        zstar(i,5) = smoke 
        
        do k = 1, nk
        
            temp = 39.d0/40.14285714d0
                      
            u(1) = 1.d0
            u(2) = temp
            u(3) = temp**2
            u(4) = temp**3
            do jj = 1, 3
	          ttemp = temp - tstar(jj)
	          if (ttemp .lt. 0.d0) then
	              ttemp = 0.d0
	          endif
	          u(jj+4) = ttemp**3	          
	      enddo

            do l = 1, nu
                uustar(k,l) = 0.d0
            enddo
            do l = 1, nr
                uustar(k,nr*(k-1)+l) = u(l)
            enddo
                        
        enddo
       
	enddo    
			
	do i = 1, ni
	  do j = 1, nj
            imiss(i,j) = 1
            if (y(i,j,1) .lt. 0.d0) then
                imiss(i,j) = 0
            endif
        enddo
      enddo
            	            
c     set hyper-parameters

      sigma_betaa = 100.d0 
      sigma_theta = 100.d0
      d0 = dfloat(nk) + 0.1d0     ; s0 = 0.1d0    
      d1 = dfloat(nu) + 0.00001d0 ; s1 = 0.00001d0     
      a0 = 1.0d0 ; b0 = 0.1d0

      sigma_gammaa = 100.d0
      sigma_alpha = 100.d0
      sigma_delta = 100.d0    
      a1 = 1.0d0 ; b1 = 1.d0

	api = dconst('pi')
	ezeta = dsqrt(2.d0/api) 
      exi = dsqrt(2.d0/api)
            
c     set initial values

      do i = 1, ni
        do j = 1, nj        
            rstar(i,j) = 0.d0    
            lambda(i,j) = 1.d0        
            do k = 1, nk        
		        xi(i,j,k) = exi
		    enddo
        enddo                        
      enddo
            
      do i = 1, ni
        w(i) = 0.d0
        eta(i) = 1.d0
        zeta(i) = ezeta
      enddo                     

      read(6,*) theta
      read(6,*) betaa        
      read(6,*) gammaa
      read(6,*) alpha
      read(6,*) delta, v1, vv
      read(6,*) sigma
      read(6,*) omega
                                          
      call rnset(iseed)    

      do ir = 1, 100
	  call gibbs_w(iseed)
	  call gibbs_zeta(iseed)
	  call gibbs_rstar(iseed)
	  call gibbs_xi(iseed)
	enddo
                  
      icount = 0
	do ir = 1, 100000
	
        call gibbs(iseed)	
        
        if (ir - ir/5*5 .eq. 1) then

            icount = icount + 1
                                            
            write(11,2) icount, theta
            write(12,2) icount, betaa        
            write(13,2) icount, gammaa
            write(14,2) icount, alpha
            write(15,2) icount, delta, v1, vv
            write(16,2) icount, sigma
            write(17,2) icount, omega

        endif
                                                    
      enddo


    1 format(i6, 1000f10.5)
    2 format(i6, 1000f20.10)

	end program
       
	include 'FFetalGrowth_Gibbs.f'
	include 'tnorm.f'
	include 'optim1.f'


