	subroutine gibbs(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk)
      real*8 vv, omega(nu,nu)
      
      real*8 bw(ni), zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta, v1, api
                 
      real*8 sigma_betaa, sigma_theta
      real*8 d0, s0, d1, s1, a0, b0
      real*8 sigma_gammaa, sigma_alpha, sigma_delta
      real*8 a1, b1
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vvv/vv          
      common /vomega/omega     
      
      common /vbw/bw
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta
      common /vv1/v1
      
      common /vsigma_betaa/sigma_betaa
      common /vsigma_theta/sigma_theta
      common /vd0/d0
      common /vs0/s0
      common /vd1/d1
      common /vs1/s1
      common /va0/a0
      common /vb0/b0     

      common /vsigma_gammaa/sigma_gammaa
      common /vsigma_alpha/sigma_alpha
      common /vsigma_delta/sigma_delta
      common /va1/a1
      common /vb1/b1

	call gibbs_xi(iseed)

	call gibbs_betaa_theta(iseed)

  
	call gibbs_w(iseed)

	call gibbs_zeta(iseed)

	call gibbs_gammaa_delta(iseed)


	call gibbs_rstar(iseed)

	call gibbs_omega(iseed)

	call gibbs_alpha(iseed)


	call gibbs_sigma(iseed)


	call gibbs_vv(iseed)

	call gibbs_lambda(iseed)


	call gibbs_v1(iseed)

	call gibbs_eta(iseed)

	end subroutine


	subroutine gibbs_zeta(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), omega(nu,nu)
      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta

      real*8 sigmaj(nk,nk)
      real*8 sigmaj_inv(nk,nk)
      real*8 omega_inv(nu,nu)
      real*8 us(nu,nk), usu(nu,nu), usy(nu)
      real*8 ystar(nk), xb, wstar, zg, ualpha(nu)
      
      real*8 sum_usu(nu,nu), sum_usx(nu,nx), sum_usy(nu)

      real*8 AA(nu,nu), AA_inv(nu,nu), BB(nu)
      real*8 aaa, aab
      
      real*8 hmean, hsigma, amean, asigma, trim, rv

      logical la, lb
                 
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vomega/omega     
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      external ytuvn, dlinrg, dblinf

	call dlinrg(nu, omega, nu, omega_inv, nu)
      
      do i = 1, ni

        do j1 = 1, nu
            sum_usy(j1) = 0.d0
            do j2 = 1, nu
                sum_usu(j1,j2) = 0.d0
            enddo
        enddo

        do j = 1, nj
        
            if (imiss(i,j) .eq. 1) then

	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo        

	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do j1 = 1, nu
                    do j2 = 1, nk
                        us(j1,j2) = 0.d0
                        do jj = 1, nk
                            us(j1,j2) = us(j1,j2) 
     +                                + ustar(i,j,jj,j1)
     +                                  *sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do k = 1, nk
                
                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo                
                
                    ystar(k) = y(i,j,k) - xb 
     +                       - theta(k)*(xi(i,j,k) - exi)     
     
                enddo

                do j1 = 1, nu
                
                    usy(j1) = 0.d0                
                    do j2 = 1, nk
                        usy(j1) = usy(j1) 
     +                          + us(j1,j2)*ystar(j2)
                    enddo

                    do j2 = 1, nu
                        usu(j1,j2) = 0.d0
                        do jj = 1, nk
                            usu(j1,j2) = usu(j1,j2) 
     +                      + us(j1,jj)*ustar(i,j,jj,j2)
                        enddo
                    enddo
                                        
                enddo

                do j1 = 1, nu
                
                    sum_usy(j1) = sum_usy(j1) 
     +                          + lambda(i,j)*usy(j1)

                    do j2 = 1, nu
                        sum_usu(j1,j2) = sum_usu(j1,j2) 
     +                  + lambda(i,j)*usu(j1,j2)
                    enddo
                    
                enddo

            endif
            
        enddo

        do j1 = 1, nu
            ualpha(j1) = 0.d0
            do j2 = 1, nk
                ualpha(j1) = ualpha(j1) 
     +                     + uustar(j2,j1)*alpha(j2)
            enddo
        enddo

        do j1 = 1, nu
            do j2 = 1, nu
                AA(j1,j2) = sum_usu(j1,j2) 
     +                    + omega_inv(j1,j2) 
     +                    + eta(i)*ualpha(j1)*ualpha(j2)
            enddo
        enddo

	  call dlinrg(nu, AA, nu, AA_inv, nu)

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      

        wstar = w(i) - zg + delta*ezeta

        do jj = 1, nu
            BB(jj) = sum_usy(jj) + eta(i)*ualpha(jj)*wstar
        enddo

        aaa = dblinf(nu, nu, AA_inv, nu, ualpha, ualpha)
        aab = dblinf(nu, nu, AA_inv, nu, ualpha, BB)

        hmean = eta(i)*delta*(wstar - aab) 
            
        hsigma = eta(i)*delta**2*(1.d0 - eta(i)*aaa) + 1.d0
                     
        amean = hmean/hsigma
        asigma = 1.d0/hsigma

        trim = -amean/dsqrt(asigma)
            
        la = .false. ; lb = .true.

		call rnset(iseed)
		rv = ytuvn(trim, trim, la, lb, iseed)
		call rnget(iseed)
		zeta(i) = amean + rv*dsqrt(asigma) 
        
      enddo  
                         
      end subroutine       


	subroutine gibbs_gammaa_delta(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
      integer, parameter :: nnc1 = nnc+1

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), omega(nu,nu)
      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta
      real*8 sigma_gammaa, sigma_delta

      real*8 sigmaj(nk,nk)
      real*8 sigmaj_inv(nk,nk)
      real*8 omega_inv(nu,nu)
      real*8 us(nu,nk), usu(nu,nu), usy(nu)
      real*8 ystar(nk), xb, ualpha(nu)
      
      real*8 sum_usu(nu,nu), sum_usx(nu,nx), sum_usy(nu)

      real*8 AA(nu,nu), AA_inv(nu,nu), BB(nu)
      real*8 aaa, aab

      real*8 zstar1(nnc1)
      
      real*8 hmean(nnc1), hsigma(nnc1,nnc1)
      real*8 amean(nnc1), asigma(nnc1,nnc1)
	real*8 tol, rsig(nnc1,nnc1), rv(nnc1)
                 
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vomega/omega     
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      common /vsigma_gammaa/sigma_gammaa
      common /vsigma_delta/sigma_delta

      external dlinrg, dblinf, dmach, dchfac, drnmvn

	call dlinrg(nu, omega, nu, omega_inv, nu)

      do j1 = 1, nnc1
        hmean(j1) = 0.d0
        do j2 = 1, nnc1
            hsigma(j1,j2) = 0.d0
        enddo
      enddo
      
      do i = 1, ni

        do j1 = 1, nu
            sum_usy(j1) = 0.d0
            do j2 = 1, nu
                sum_usu(j1,j2) = 0.d0
            enddo
        enddo

        do j = 1, nj
        
            if (imiss(i,j) .eq. 1) then

	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo        

	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do j1 = 1, nu
                    do j2 = 1, nk
                        us(j1,j2) = 0.d0
                        do jj = 1, nk
                            us(j1,j2) = us(j1,j2) 
     +                                + ustar(i,j,jj,j1)
     +                                  *sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do k = 1, nk
                
                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo                
                
                    ystar(k) = y(i,j,k) - xb 
     +                       - theta(k)*(xi(i,j,k) - exi)     
     
                enddo

                do j1 = 1, nu
                
                    usy(j1) = 0.d0                
                    do j2 = 1, nk
                        usy(j1) = usy(j1) 
     +                          + us(j1,j2)*ystar(j2)
                    enddo

                    do j2 = 1, nu
                        usu(j1,j2) = 0.d0
                        do jj = 1, nk
                            usu(j1,j2) = usu(j1,j2) 
     +                      + us(j1,jj)*ustar(i,j,jj,j2)
                        enddo
                    enddo
                                        
                enddo

                do j1 = 1, nu
                
                    sum_usy(j1) = sum_usy(j1) 
     +                          + lambda(i,j)*usy(j1)

                    do j2 = 1, nu
                        sum_usu(j1,j2) = sum_usu(j1,j2) 
     +                  + lambda(i,j)*usu(j1,j2)
                    enddo
                    
                enddo

            endif
            
        enddo

        do j1 = 1, nu
            ualpha(j1) = 0.d0
            do j2 = 1, nk
                ualpha(j1) = ualpha(j1) 
     +                     + uustar(j2,j1)*alpha(j2)
            enddo
        enddo

        do j1 = 1, nu
            do j2 = 1, nu
                AA(j1,j2) = sum_usu(j1,j2) 
     +                    + omega_inv(j1,j2) 
     +                    + eta(i)*ualpha(j1)*ualpha(j2)
            enddo
        enddo

	  call dlinrg(nu, AA, nu, AA_inv, nu)
                    
        do jj = 1, nu
            BB(jj) = sum_usy(jj) + eta(i)*ualpha(jj)*w(i)
        enddo

        aaa = dblinf(nu, nu, AA_inv, nu, ualpha, ualpha)
        aab = dblinf(nu, nu, AA_inv, nu, ualpha, BB)

        do j1 = 1, nnc
            zstar1(j1) = zstar(i,j1)
        enddo
        zstar1(nnc+1) = zeta(i) - ezeta

        do j1 = 1, nnc1
        
            do j2 = 1, nnc1
            
                hsigma(j1,j2) = hsigma(j1,j2) 
     +                        + eta(i)*(1.d0 - eta(i)*aaa)
     +                          *zstar1(j1)*zstar1(j2)
     
            enddo
            
            hmean(j1) = hmean(j1) 
     +                + eta(i)*(w(i) - aab)*zstar1(j1)
     
        enddo
                
      enddo  
      
      do j1 = 1, nnc
        hsigma(j1,j1) = hsigma(j1,j1) + 1.d0/sigma_gammaa
      enddo
      hsigma(nnc1,nnc1) = hsigma(nnc1,nnc1) + 1.d0/sigma_delta

	call dlinrg(nnc1, hsigma, nnc1, asigma, nnc1)
	
	do j1 = 1, nnc1
	  amean(j1) = 0.d0
		do j2 = 1, nnc1
		    amean(j1) = amean(j1) + asigma(j1,j2)*hmean(j2)
		enddo
	enddo

	tol = 100.d0*dmach(4)
	call dchfac(nnc1, asigma, nnc1, tol, irank, rsig, nnc1)
	call rnset(iseed)
	call drnmvn(1, nnc1, rsig, nnc1, rv, 1)
	call rnget(iseed)      
	
	do j = 1, nnc
	  gammaa(j) = amean(j) + rv(j)
	enddo      
	delta = amean(nnc+1) + rv(nnc+1)  
                         
      end subroutine      


	subroutine gibbs_v1(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
	integer, parameter :: npoint = 5, ndim = 3

      real*8 rstar(ni,nu)      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta, v1, a1, b1

	real*8 start(1), xmin(1), ynewlo, reqmin, step(1)
	integer konvge, kcount, icount, numres, ifault, nopt

	real*8 old, new, amean, asigma
	real*8 rv, u, bpdf, apdf, ratio

      real*8 epsilon, astar(npoint)
      real*8 yystar(npoint), xxstar(npoint,ndim)
      real*8 xx(ndim,ndim), xy(ndim)
      real*8 xx_inv(ndim,ndim), xhat(ndim)

	real*8 wstar, zg, ur, aub
      real*8 suma, sumb

      common /vrstar/rstar                
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta
      common /vv1/v1

      common /va1/a1
      common /vb1/b1

      common /vsuma/suma
      common /vsumb/sumb

      external fv1, dlinrg, drnnof, drnunf

      epsilon = 0.1d0
      
      suma = 0.d0 ; sumb = 0.d0
      do i = 1, ni

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      

        aub = 0.d0
        do k = 1, nk
            ur = 0.d0
            do j = 1, nu
                ur = ur + uustar(k,j)*rstar(i,j)
            enddo
            aub = aub + alpha(k)*ur  
        enddo
        
        wstar = w(i) - zg - aub - delta*(zeta(i) - ezeta)

        suma = suma + dlog(1.d0 + wstar**2)
        sumb = sumb + 1.d0
              
      enddo  

      old = dlog(v1 - 1.d0)
      
	nopt = 1
	reqmin = 1.0d-10 ; konvge = 5 ; kcount = 1000
	do i = 1, 1
	  step(i) = 0.2d0 ; start(i) = old
	enddo	
	call nelmin(fv1,nopt,start,xmin,ynewlo,reqmin, 
     +		      step,konvge,kcount,icount,numres,ifault)
      amean = xmin(1)
      
      astar(1) = amean - 2.d0*epsilon      
      astar(2) = amean - epsilon
      astar(3) = amean 
      astar(4) = amean + epsilon
      astar(5) = amean + 2.d0*epsilon      
      do kk = 1, npoint
          yystar(kk) = -fv1(astar(kk))
          xxstar(kk,1) = astar(kk)**2
          xxstar(kk,2) = astar(kk)
          xxstar(kk,3) = 1.d0
      enddo
      do k1 = 1, ndim
          do k2 = 1, ndim
              xx(k1,k2) = 0.d0
              do kk = 1, npoint
                  xx(k1,k2) = xx(k1,k2) 
     +                      + xxstar(kk,k1)
     +                        *xxstar(kk,k2)
              enddo
          enddo
          xy(k1) = 0.d0
          do k2 = 1, npoint
              xy(k1) = xy(k1) + xxstar(k2,k1)*yystar(k2)
          enddo
      enddo
	call dlinrg(ndim, xx, ndim, xx_inv, ndim)
      do k1 = 1, ndim
          xhat(k1) = 0.d0
          do k2 = 1, ndim
              xhat(k1) = xhat(k1) + xx_inv(k1,k2)*xy(k2)
          enddo
      enddo

      asigma = -1.d0/(2.d0*xhat(1))*1.5d0
      if (asigma .lt. 0.0d0) asigma = -asigma      

      bpdf = -fv1(old) 
     +     + (old - amean)**2/(2.d0*asigma)
                
      do ii = 1, 50
	  
        call rnset(iseed)
	  rv = drnnof()
	  call rnget(iseed)
		new = amean + rv*dsqrt(asigma)

		apdf = -fv1(new) 
     +       + (new - amean)**2/(2.d0*asigma)
		ratio = apdf - bpdf 
     
        if (ratio .ge. 0.0d0) then
		    bpdf = apdf
		    old = new
	  else
		    call rnset(iseed)
		    u = drnunf()
		    call rnget(iseed)
		    if (dlog(u) .le. ratio) then
		        bpdf = apdf
		        old = new
			endif
		endif
		
      enddo     
      
      v1 = 1.d0 + dexp(old)
                         
      end subroutine      


      real*8 function fv1(v1)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 a1, b1, suma, sumb
      real*8 v1, ev1, pdf
      
      common /va1/a1
      common /vb1/b1

      common /vsuma/suma
      common /vsumb/sumb

      external dlngam

      ev1 = 1.d0 + dexp(v1)
              
      pdf = -ev1*suma/2.d0 
     +    + sumb*(dlngam((ev1 + 1.d0)/2.d0)
     +            - dlngam(ev1/2.d0) )
     +    + (a1 - 1.d0)*dlog(ev1) - b1*ev1 + v1
      
      fv1 = -pdf
      
	end function


	subroutine gibbs_eta(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 rstar(ni,nu)      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta, v1

	real*8 wstar, zg, ur, aub
	real*8 shape, scale, rv

      common /vrstar/rstar                
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta
      common /vv1/v1

      external drngam      
      
      do i = 1, ni

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      

        aub = 0.d0
        do k = 1, nk
            ur = 0.d0
            do j = 1, nu
                ur = ur + uustar(k,j)*rstar(i,j)
            enddo
            aub = aub + alpha(k)*ur  
        enddo
        
        wstar = w(i) - zg - aub - delta*(zeta(i) - ezeta)
      
        shape = (v1 + 1.d0)/2.d0      
        scale = (1.d0 + wstar**2)/2.d0

		call rnset(iseed)
		call drngam(1, shape, rv)
		call rnget(iseed)
		eta(i) = rv/scale    
        
      enddo  
                         
      end subroutine      


	subroutine gibbs_vv(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
	integer, parameter :: npoint = 5, ndim = 3

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 sigma(nj,nk,nk), vv
      real*8 a0, b0

	real*8 start(1), xmin(1), ynewlo, reqmin, step(1)
	integer konvge, kcount, icount, numres, ifault, nopt

	real*8 old, new, amean, asigma
	real*8 rv, u, bpdf, apdf, ratio

      real*8 epsilon, astar(npoint)
      real*8 yystar(npoint), xxstar(npoint,ndim)
      real*8 xx(ndim,ndim), xy(ndim)
      real*8 xx_inv(ndim,ndim), xhat(ndim)

      real*8 sigmaj(nk,nk), sigmaj_inv(nk,nk)
      real*8 ystar(nk), xb, ub, temp, suma, sumb
                
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vsigma/sigma

      common /vvv/vv          

      common /va0/a0
      common /vb0/b0     

      common /vsuma/suma
      common /vsumb/sumb

      external fvv, dlinrg, drnnof, drnunf

      epsilon = 0.1d0
                
      suma = 0.d0 ; sumb = 0.d0
      do j = 1, nj   

	  do k1 = 1, nk
	      do k2 = 1, nk
	          sigmaj(k1,k2) = sigma(j,k1,k2)
	      enddo	      	      
	  enddo        

	  call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

        do i = 1, ni

            if (imiss(i,j) .eq. 1) then
                          
                do k = 1, nk

                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo

                    ub = 0.d0                        
                    do jj = 1, nu
                        ub = ub + ustar(i,j,k,jj)*rstar(i,jj)
                    enddo
                
                    ystar(k) = y(i,j,k) - xb - ub
     +                       - theta(k)*(xi(i,j,k) - exi)
     
                enddo        
            
                temp = dblinf(nk,nk,sigmaj_inv,nk,ystar,ystar)
            
                suma = suma + dlog(1.d0 + temp)
                sumb = sumb + 1.d0
            
            endif
            
        enddo

      enddo
      
      old = dlog(vv - 1.d0)
      
      nopt = 1
	reqmin = 1.0d-10 ; konvge = 5 ; kcount = 1000
	do j = 1, 1
	  step(j) = 0.2d0 ; start(j) = old
	enddo	
	call nelmin(fvv,nopt,start,xmin,ynewlo,reqmin, 
     +	          step,konvge,kcount,icount,numres,ifault)
      amean = xmin(1)          
            
      astar(1) = amean - 2.d0*epsilon      
      astar(2) = amean - epsilon
      astar(3) = amean 
      astar(4) = amean + epsilon
      astar(5) = amean + 2.d0*epsilon      
      do kk = 1, npoint
          yystar(kk) = -fvv(astar(kk))
          xxstar(kk,1) = astar(kk)**2
          xxstar(kk,2) = astar(kk)
          xxstar(kk,3) = 1.d0
      enddo
      do k1 = 1, ndim
          do k2 = 1, ndim
              xx(k1,k2) = 0.d0
              do kk = 1, npoint
                  xx(k1,k2) = xx(k1,k2) 
     +                      + xxstar(kk,k1)
     +                        *xxstar(kk,k2)
              enddo
          enddo
          xy(k1) = 0.d0
          do k2 = 1, npoint
              xy(k1) = xy(k1) + xxstar(k2,k1)*yystar(k2)
          enddo
      enddo
	call dlinrg(ndim, xx, ndim, xx_inv, ndim)
      do k1 = 1, ndim
          xhat(k1) = 0.d0
          do k2 = 1, ndim
              xhat(k1) = xhat(k1) + xx_inv(k1,k2)*xy(k2)
          enddo
      enddo

      asigma = -1.d0/(2.d0*xhat(1))*1.5d0
      if (asigma .lt. 0.0d0) asigma = -asigma      

      bpdf = -fvv(old) 
     +     + (old - amean)**2/(2.d0*asigma)
                
      do ii = 1, 50
	  
        call rnset(iseed)
	  rv = drnnof()
	  call rnget(iseed)
		new = amean + rv*dsqrt(asigma)

		apdf = -fvv(new) 
     +       + (new - amean)**2/(2.d0*asigma)
		ratio = apdf - bpdf 
     
        if (ratio .ge. 0.0d0) then
		    bpdf = apdf
		    old = new
	  else
		    call rnset(iseed)
		    u = drnunf()
		    call rnget(iseed)
		    if (dlog(u) .le. ratio) then
		        bpdf = apdf
		        old = new
			endif
		endif
		
      enddo     
      
      vv = 1.d0 + dexp(old) 
                       
      end subroutine


      real*8 function fvv(vv)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 a0, b0, suma, sumb
      
      real*8 vv, evv, pdf
            
      common /va0/a0
      common /vb0/b0

      common /vsuma/suma
      common /vsumb/sumb

      external dlngam
      
      evv = 1.d0 + dexp(vv)
            
      pdf = -evv*suma/2.d0 
     +    + sumb*(dlngam((evv + dfloat(nk))/2.d0) 
     +            - dlngam(evv/2.d0))
     +    + (a0 - 1.d0)*dlog(evv) - b0*evv + vv
                                  
      fvv = -pdf
     
	end function


	subroutine gibbs_lambda(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), vv
      
      real*8 sigmaj(nk,nk), sigmaj_inv(nk,nk)
      real*8 ystar(nk), xb, ub, temp
      real*8 shape, scale, rv
          
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma

      common /vvv/vv          

      external dlinrg, dblinf, drngam
                
      do j = 1, nj   

	  do k1 = 1, nk
	      do k2 = 1, nk
	          sigmaj(k1,k2) = sigma(j,k1,k2)
	      enddo	      	      
	  enddo        

	  call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

        do i = 1, ni

            if (imiss(i,j) .eq. 1) then
                          
                do k = 1, nk

                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo

                    ub = 0.d0                        
                    do jj = 1, nu
                        ub = ub + ustar(i,j,k,jj)*rstar(i,jj)
                    enddo
                
                    ystar(k) = y(i,j,k) - xb - ub
     +                       - theta(k)*(xi(i,j,k) - exi)
                enddo        

                temp = dblinf(nk,nk,sigmaj_inv,nk,ystar,ystar)
            
                shape = (vv + dfloat(nk))/2.d0
                scale = (1.d0 + temp)/2.d0

	          call rnset(iseed)
	          call drngam(1, shape, rv)
	          call rnget(iseed)

                lambda(i,j) = rv/scale      

            else

                lambda(i,j) = -999.d0 
                        
            endif
            
        enddo
        
      enddo
                                    
      end subroutine


	subroutine gibbs_alpha(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 rstar(ni,nu)      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta, sigma_alpha

      real*8 hmean(nk), hsigma(nk,nk)
      real*8 amean(nk), asigma(nk,nk)
	real*8 tol, rsig(nk,nk), rv(nk)

	real*8 wstar, zg, ur(nk)

      common /vrstar/rstar                
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      common /vsigma_alpha/sigma_alpha

      external dlinrg, dmach, dchfac, drnmvn

      do j1 = 1, nk
        hmean(j1) = 0.d0
        do j2 = 1, nk
            hsigma(j1,j2) = 0.d0
        enddo
      enddo
      
      do i = 1, ni

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      

        do k = 1, nk
            ur(k) = 0.d0
            do j = 1, nu
                ur(k) = ur(k) + uustar(k,j)*rstar(i,j)
            enddo
        enddo
        
        wstar = w(i) - zg - delta*(zeta(i) - ezeta)

        do j1 = 1, nk
            hmean(j1) = hmean(j1) + eta(i)*ur(j1)*wstar
            do j2 = 1, nk
                hsigma(j1,j2) = hsigma(j1,j2) 
     +                        + eta(i)*ur(j1)*ur(j2)
            enddo
        enddo           
              
      enddo  

      do j1 = 1, nk
        hsigma(j1,j1) = hsigma(j1,j1) + 1.d0/sigma_alpha
      enddo

	call dlinrg(nk, hsigma, nk, asigma, nk)
	
	do j1 = 1, nk
	  amean(j1) = 0.d0
		do j2 = 1, nk
		    amean(j1) = amean(j1) + asigma(j1,j2)*hmean(j2)
		enddo
	enddo

	tol = 100.d0*dmach(4)
	call dchfac(nk, asigma, nk, tol, irank, rsig, nk)
	call rnset(iseed)
	call drnmvn(1, nk, rsig, nk, rv, 1)
	call rnget(iseed)      
	
	do k = 1, nk
	  alpha(k) = amean(k) + rv(k)
	enddo      
                         
      end subroutine      


	subroutine gibbs_w(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), omega(nu,nu)
      
      real*8 bw(ni), zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta

      real*8 sigmaj(nk,nk)
      real*8 sigmaj_inv(nk,nk)
      real*8 omega_inv(nu,nu)
      real*8 us(nu,nk), usu(nu,nu), usy(nu)
      real*8 ystar(nk), xb, zg, wstar, ualpha(nu)
      
      real*8 sum_usu(nu,nu), sum_usy(nu)

      real*8 AA(nu,nu), AA_inv(nu,nu), BB(nu)
      real*8 aaa, aab, amean, asigma
	real*8 wmean, wsigma, trim, rv
           
      logical la, lb
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vomega/omega     
      
      common /vbw/bw
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      external ytuvn, dlinrg, dblinf

	call dlinrg(nu, omega, nu, omega_inv, nu)
      
      do i = 1, ni

        do j1 = 1, nu
            sum_usy(j1) = 0.d0
            do j2 = 1, nu
                sum_usu(j1,j2) = 0.d0
            enddo
        enddo

        do j = 1, nj
        
            if (imiss(i,j) .eq. 1) then

	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo        

	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do j1 = 1, nu
                    do j2 = 1, nk
                        us(j1,j2) = 0.d0
                        do jj = 1, nk
                            us(j1,j2) = us(j1,j2) 
     +                                + ustar(i,j,jj,j1)
     +                                  *sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do k = 1, nk
                
                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo                
                
                    ystar(k) = y(i,j,k) - xb 
     +                       - theta(k)*(xi(i,j,k) - exi)     
     
                enddo

                do j1 = 1, nu
                
                    usy(j1) = 0.d0                
                    do j2 = 1, nk
                        usy(j1) = usy(j1) 
     +                          + us(j1,j2)*ystar(j2)
                    enddo

                    do j2 = 1, nu
                        usu(j1,j2) = 0.d0
                        do jj = 1, nk
                            usu(j1,j2) = usu(j1,j2) 
     +                      + us(j1,jj)*ustar(i,j,jj,j2)
                        enddo
                    enddo
                                        
                enddo
                
                do j1 = 1, nu
                
                    sum_usy(j1) = sum_usy(j1) 
     +                          + lambda(i,j)*usy(j1)

                    do j2 = 1, nu
                        sum_usu(j1,j2) = sum_usu(j1,j2) 
     +                  + lambda(i,j)*usu(j1,j2)
                    enddo
                    
                enddo
                
            endif
            
        enddo

        do j1 = 1, nu
            ualpha(j1) = 0.d0
            do j2 = 1, nk
                ualpha(j1) = ualpha(j1) 
     +                     + uustar(j2,j1)*alpha(j2)
            enddo
        enddo

        do j1 = 1, nu
            do j2 = 1, nu
                AA(j1,j2) = sum_usu(j1,j2) 
     +                    + omega_inv(j1,j2) 
     +                    + eta(i)*ualpha(j1)*ualpha(j2)
            enddo
        enddo

	  call dlinrg(nu, AA, nu, AA_inv, nu)       

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      
       
        wstar = zg + delta*(zeta(i) - ezeta) 
      
        do jj = 1, nu
            BB(jj) = eta(i)*ualpha(jj)*wstar - sum_usy(jj)
        enddo

        aaa = dblinf(nu, nu, AA_inv, nu, ualpha, ualpha)
        aab = dblinf(nu, nu, AA_inv, nu, ualpha, BB)

        amean = eta(i)*(wstar - aab)
        asigma = eta(i)*(1.d0 - eta(i)*aaa)

        wmean = amean/asigma
        wsigma = 1.d0/asigma

		trim = -wmean/dsqrt(wsigma)
		if (bw(i) .eq. 0.d0) then
		    la = .true. ; lb = .false.
		else
		    la = .false. ; lb = .true.
		endif

		call rnset(iseed)
		rv = ytuvn(trim, trim, la, lb, iseed)
		call rnget(iseed)
		w(i) = wmean + rv*dsqrt(wsigma)         
        
      enddo  
                         
      end subroutine      


	subroutine gibbs_xi(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk)
      
      real*8 sigmaj(nk,nk), sigmaj_inv(nk,nk)
      real*8 ystar(nk), xb, ub
                    
      real*8 tstar(nk,nk), ts(nk,nk), tst(nk,nk), tsy(nk)

      real*8 hmean(nk), hsigma(nk,nk)
      real*8 amean, asigma, xmean, xsigma, trim, rv
      
      logical la, lb
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma

      external ytuvn, dlinrg
     
      do k1 = 1, nk
        do k2 = 1, nk
            tstar(k1,k2) = 0.d0
        enddo
        tstar(k1,k1) = theta(k1)
      enddo
      
      do i = 1, ni

        do j = 1, nj
                   
            if (imiss(i,j) .eq. 1) then
                
	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo       
	          
	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do k = 1, nk
                
                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo

                    ub = 0.d0                        
                    do jj = 1, nu
                        ub = ub + ustar(i,j,k,jj)*rstar(i,jj)
                    enddo
                
                    ystar(k) = y(i,j,k) - xb - ub + theta(k)*exi
     
                enddo

                do k1 = 1, nk
                    do k2 = 1, nk
                        ts(k1,k2) = 0.d0
                        do kk = 1, nk
                            ts(k1,k2) = ts(k1,k2) 
     +                                + tstar(kk,k1)
     +                                  *sigmaj_inv(kk,k2)
                        enddo
                    enddo
                enddo

                do k1 = 1, nk

                    tsy(k1) = 0.d0                
                    do k2 = 1, nk
                        tsy(k1) = tsy(k1) 
     +                          + ts(k1,k2)*ystar(k2)
                    enddo
                
                    do k2 = 1, nk
                        tst(k1,k2) = 0.d0
                        do kk = 1, nk
                            tst(k1,k2) = tst(k1,k2) 
     +                                 + ts(k1,kk)*tstar(kk,k2)
                        enddo
                    enddo
                    
                enddo

                do k1 = 1, nk
        
                    hmean(k1) = lambda(i,j)*tsy(k1) 
                   
                    do k2 = 1, nk
                
                        hsigma(k1,k2) = lambda(i,j)*tst(k1,k2)
                    
                    enddo

                    hsigma(k1,k1) = hsigma(k1,k1) + 1.d0
                            
                enddo      

                do ir = 1, 10
                do k1 = 1, nk
        
                    asigma = hsigma(k1,k1)
            
                    amean = hmean(k1)
                    do k2 = 1, nk
                        if (k2 .ne. k1) then
                            amean = amean - hsigma(k1,k2)*xi(i,j,k2)
                        endif
                    enddo
        
                    xmean = amean/asigma
                    xsigma = 1.d0/asigma
                        
                    trim = -xmean/dsqrt(xsigma)
            
                    la = .false. ; lb = .true.

		            call rnset(iseed)
		            rv = ytuvn(trim, trim, la, lb, iseed)
		            call rnget(iseed)
		    
		            xi(i,j,k1) = xmean + rv*dsqrt(xsigma) 

                enddo
                enddo

            else
        
                do k = 1, nk
                    xi(i,j,k) = -999.d0
                enddo
                    
            endif
            
        enddo
                                
      enddo
      
      end subroutine      


	subroutine gibbs_betaa_theta(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
      integer, parameter :: nx1 = nx+nk

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), omega(nu,nu)
      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta

      real*8 sigma_betaa, sigma_theta

      real*8 sigmaj(nk,nk)
      real*8 sigmaj_inv(nk,nk)
      real*8 omega_inv(nu,nu)
      real*8 us(nu,nk), usu(nu,nu), usy(nu)
      real*8 xx(nk,nx1), usx(nu,nx1)
      real*8 xs(nx1,nk), xsx(nx1,nx1), xsy(nx1)
      real*8 ystar(nk), zg, wstar, ualpha(nu)
      
      real*8 sum_usu(nu,nu), sum_usx(nu,nx1), sum_usy(nu)
      real*8 sum_xsx(nx1,nx1), sum_xsy(nx1)
      
      real*8 AA(nu,nu), AA_inv(nu,nu), BB(nu)
      real*8 CA(nx1,nu), CAC(nx1,nx1), CAB(nx1)

      real*8 hmean(nx1), hsigma(nx1,nx1)
      real*8 amean(nx1), asigma(nx1,nx1)
	real*8 tol, rsig(nx1,nx1), rv(nx1)
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vomega/omega     
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      common /vsigma_betaa/sigma_betaa
      common /vsigma_theta/sigma_theta

      external dlinrg, dmach, dchfac, drnmvn

	call dlinrg(nu, omega, nu, omega_inv, nu)

      do j1 = 1, nx1
        hmean(j1) = 0.d0
        do j2 = 1, nx1
            hsigma(j1,j2) = 0.d0
        enddo
      enddo
      
      do i = 1, ni

        do j1 = 1, nu
            sum_usy(j1) = 0.d0
            do j2 = 1, nu
                sum_usu(j1,j2) = 0.d0
            enddo
            do j2 = 1, nx1
                sum_usx(j1,j2) = 0.d0
            enddo
        enddo

        do j1 = 1, nx1
            sum_xsy(j1) = 0.d0
            do j2 = 1, nx1
                sum_xsx(j1,j2) = 0.d0
            enddo
        enddo

        do j = 1, nj
        
            if (imiss(i,j) .eq. 1) then

	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo        

	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do j1 = 1, nu
                    do j2 = 1, nk
                        us(j1,j2) = 0.d0
                        do jj = 1, nk
                            us(j1,j2) = us(j1,j2) 
     +                                + ustar(i,j,jj,j1)
     +                                  *sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do j1 = 1, nk
                    do j2 = 1, nx1
                        xx(j1,j2) = 0.d0
                    enddo
                enddo
                do k = 1, nk
                    do jj = 1, nx
                        xx(k,jj) = xstar(i,j,k,jj)
                    enddo
                    xx(k,nx+k) = xi(i,j,k) - exi
                enddo

                do j1 = 1, nx1
                    do j2 = 1, nk
                        xs(j1,j2) = 0.d0
                        do jj = 1, nk
                            xs(j1,j2) = xs(j1,j2) 
     +                      + xx(jj,j1)*sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do k = 1, nk
                    ystar(k) = y(i,j,k) 
                enddo

                do j1 = 1, nu
                
                    usy(j1) = 0.d0                
                    do j2 = 1, nk
                        usy(j1) = usy(j1) 
     +                          + us(j1,j2)*ystar(j2)
                    enddo

                    do j2 = 1, nu
                        usu(j1,j2) = 0.d0
                        do jj = 1, nk
                            usu(j1,j2) = usu(j1,j2) 
     +                      + us(j1,jj)*ustar(i,j,jj,j2)
                        enddo
                    enddo
                    
                    do j2 = 1, nx1
                        usx(j1,j2) = 0.d0
                        do jj = 1, nk
                            usx(j1,j2) = usx(j1,j2) 
     +                                 + us(j1,jj)*xx(jj,j2)
                        enddo
                    enddo
                    
                enddo

                do j1 = 1, nx1
                
                    xsy(j1) = 0.d0                
                    do j2 = 1, nk
                        xsy(j1) = xsy(j1) 
     +                          + xs(j1,j2)*ystar(j2)
                    enddo
                    
                    do j2 = 1, nx1
                        xsx(j1,j2) = 0.d0
                        do jj = 1, nk
                            xsx(j1,j2) = xsx(j1,j2) 
     +                                 + xs(j1,jj)*xx(jj,j2)
                        enddo
                    enddo
                    
                enddo
                
                do j1 = 1, nu
                
                    sum_usy(j1) = sum_usy(j1) 
     +                          + lambda(i,j)*usy(j1)

                    do j2 = 1, nu
                        sum_usu(j1,j2) = sum_usu(j1,j2) 
     +                  + lambda(i,j)*usu(j1,j2)
                    enddo

                    do j2 = 1, nx1
                        sum_usx(j1,j2) = sum_usx(j1,j2) 
     +                  + lambda(i,j)*usx(j1,j2)
                    enddo
                    
                enddo

                do j1 = 1, nx1
                    sum_xsy(j1) = sum_xsy(j1) 
     +                          + lambda(i,j)*xsy(j1)
                    do j2 = 1, nx1
                        sum_xsx(j1,j2) = sum_xsx(j1,j2) 
     +                  + lambda(i,j)*xsx(j1,j2)
                    enddo
                enddo
                
            endif
            
        enddo

        do j1 = 1, nu
            ualpha(j1) = 0.d0
            do j2 = 1, nk
                ualpha(j1) = ualpha(j1) 
     +                     + uustar(j2,j1)*alpha(j2)
            enddo
        enddo

        do j1 = 1, nu
            do j2 = 1, nu
                AA(j1,j2) = sum_usu(j1,j2) 
     +                    + omega_inv(j1,j2) 
     +                    + eta(i)*ualpha(j1)*ualpha(j2)
            enddo
        enddo

	  call dlinrg(nu, AA, nu, AA_inv, nu)

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      
       
        wstar = w(i) - zg - delta*(zeta(i) - ezeta) 
            
        do jj = 1, nu
            BB(jj) = sum_usy(jj) + eta(i)*ualpha(jj)*wstar
        enddo

        do j1 = 1, nx1
            do j2 = 1, nu
                CA(j1,j2) = 0.d0
                do jj = 1, nu
                    CA(j1,j2) = CA(j1,j2) 
     +                        + sum_usx(jj,j1)*AA_inv(jj,j2)
                enddo
            enddo
        enddo

        do j1 = 1, nx1

            CAB(j1) = 0.d0
            do j2 = 1, nu           
                CAB(j1) = CAB(j1) + CA(j1,j2)*BB(j2)
            enddo        
        
            do j2 = 1, nx1
                CAC(j1,j2) = 0.d0
                do jj = 1, nu
                    CAC(j1,j2) = CAC(j1,j2) 
     +                         + CA(j1,jj)*sum_usx(jj,j2)
                enddo
            enddo
            
        enddo
                       
        do j1 = 1, nx1        
        
            hmean(j1) = hmean(j1) + sum_xsy(j1) - CAB(j1)
            
            do j2 = 1, nx1           
                
                hsigma(j1,j2) = hsigma(j1,j2) 
     +                        + sum_xsx(j1,j2) - CAC(j1,j2)

            enddo

        enddo             
        
      enddo

      do j = 1, nx
        hsigma(j,j) = hsigma(j,j) + 1.d0/sigma_betaa
      enddo
      do k = 1, nk
        hsigma(nx+k,nx+k) = hsigma(nx+k,nx+k) 
     +                    + 1.d0/sigma_theta
      enddo

	call dlinrg(nx1, hsigma, nx1, asigma, nx1)
	
	do j1 = 1, nx1
	  amean(j1) = 0.d0
		do j2 = 1, nx1
		    amean(j1) = amean(j1) + asigma(j1,j2)*hmean(j2)
		enddo
      enddo

	tol = 100.d0*dmach(4)
	call dchfac(nx1, asigma, nx1, tol, irank, rsig, nx1)
	call rnset(iseed)
	call drnmvn(1, nx1, rsig, nx1, rv, 1)
	call rnget(iseed)   
		
	do j = 1, nx
	  betaa(j) = amean(j) + rv(j)
	enddo      
	do k = 1, nk
	  theta(k) = amean(nx+k) + rv(nx+k)
	enddo      
            
      end subroutine      


	subroutine gibbs_rstar(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), omega(nu,nu)
      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 w(ni), eta(ni), gammaa(nnc), alpha(nk) 
      real*8 delta, zeta(ni), ezeta

      real*8 sigmaj(nk,nk), sigmaj_inv(nk,nk)
      real*8 omega_inv(nu,nu)
      real*8 us(nu,nk), usu(nu,nu), usy(nu)
      real*8 ystar(nk), xb, ualpha(nu), zg, wstar, temp
      
      real*8 hmean(nu), hsigma(nu,nu)
      real*8 amean(nu), asigma(nu,nu)
	real*8 tol, rsig(nu,nu), rv(nu)
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vomega/omega     
      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vw/w
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vzeta/zeta
      common /vezeta/ezeta

      external dlinrg, dmach, dchfac, drnmvn

	call dlinrg(nu, omega, nu, omega_inv, nu)

      do i = 1, ni

        do j1 = 1, nu
            hmean(j1) = 0.d0
            do j2 = 1, nu
                hsigma(j1,j2) = 0.d0
            enddo
        enddo

        do j = 1, nj
        
            if (imiss(i,j) .eq. 1) then

	          do k1 = 1, nk
	              do k2 = 1, nk
	                  sigmaj(k1,k2) = sigma(j,k1,k2)
	              enddo	      	      
	          enddo        

	          call dlinrg(nk, sigmaj, nk, sigmaj_inv, nk)

                do j1 = 1, nu
                    do j2 = 1, nk
                        us(j1,j2) = 0.d0
                        do jj = 1, nk
                            us(j1,j2) = us(j1,j2) 
     +                                + ustar(i,j,jj,j1)
     +                                  *sigmaj_inv(jj,j2)
                        enddo
                    enddo
                enddo

                do k = 1, nk

                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo
                
                    ystar(k) = y(i,j,k) - xb 
     +                       - theta(k)*(xi(i,j,k) - exi)
     
                enddo

                do j1 = 1, nu

                    usy(j1) = 0.d0
                    do j2 = 1, nk
                        usy(j1) = usy(j1) 
     +                          + us(j1,j2)*ystar(j2)
                    enddo
                
                    do j2 = 1, nu
                        usu(j1,j2) = 0.d0
                        do jj = 1, nk
                            usu(j1,j2) = usu(j1,j2) 
     +                                 + us(j1,jj)
     +                                   *ustar(i,j,jj,j2)
                        enddo
                    enddo
                    
                enddo

                do j1 = 1, nu
                    hmean(j1) = hmean(j1) 
     +                        + lambda(i,j)*usy(j1)
                    do j2 = 1, nu
                        hsigma(j1,j2) = hsigma(j1,j2) 
     +                                + lambda(i,j)*usu(j1,j2)
                    enddo
                enddo

            endif
            
        enddo

        do j1 = 1, nu
            ualpha(j1) = 0.d0
            do j2 = 1, nk
                ualpha(j1) = ualpha(j1) 
     +                     + uustar(j2,j1)*alpha(j2)
            enddo
        enddo

        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      
       
        wstar = w(i) - zg - delta*(zeta(i) - ezeta) 

        do j1 = 1, nu
            hmean(j1) = hmean(j1) + eta(i)*ualpha(j1)*wstar
            do j2 = 1, nu
                hsigma(j1,j2) = hsigma(j1,j2) 
     +                        + omega_inv(j1,j2) 
     +                        + eta(i)*ualpha(j1)*ualpha(j2)
            enddo
        enddo
       
	  call dlinrg(nu, hsigma, nu, asigma, nu)
	
	  do j1 = 1, nu
	      amean(j1) = 0.d0
		    do j2 = 1, nu
		        amean(j1) = amean(j1) 
     +                    + asigma(j1,j2)*hmean(j2)
		    enddo
	  enddo

	  tol = 100.d0*dmach(4)
	  call dchfac(nu, asigma, nu, tol, irank, rsig, nu)
	  call rnset(iseed)
	  call drnmvn(1, nu, rsig, nu, rv, 1)
	  call rnget(iseed)      
	
	  do j = 1, nu
	      rstar(i,j) = amean(j) + rv(j)
	  enddo      
      
      enddo

      end subroutine      
      
      
	subroutine gibbs_omega(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 rstar(ni,nu), omega(nu,nu)
      real*8 d1, s1

	real*8 shape, qq(nu,nu)
      
      common /vrstar/rstar
      common /vomega/omega

      common /vd1/d1
      common /vs1/s1
     
	shape = d1
      do j1 = 1, nu
        do j2 = 1, nu
			qq(j1,j2) = 0.d0
        enddo
		qq(j1,j1) = s1        
      enddo

      do i = 1, ni            

	  shape = shape + 1.d0
                                
        do j1 = 1, nu
            do j2 = 1, nu
                qq(j1,j2) = qq(j1,j2) 
     +                    + rstar(i,j1)*rstar(i,j2)
            enddo
        enddo
        
      enddo

	call gen_iwish(omega, shape, qq, nu, iseed)            
				          
	end subroutine
	

	subroutine gibbs_sigma(iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk), d0, s0
      
      real*8 ystar(nk), xb, ur
	real*8 shape, qq(nk,nk), asigma(nk,nk)
      
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      
      common /vd0/d0
      common /vs0/s0
            
      do j = 1, nj
      
	  shape = d0
        do k1 = 1, nk
            do k2 = 1, nk
			    qq(k1,k2) = 0.d0
            enddo
		    qq(k1,k1) = s0
        enddo

        do i = 1, ni            

            if (imiss(i,j) .eq. 1) then
            
	          shape = shape + 1.d0
                    
                do k = 1, nk

                    xb = 0.d0                        
                    do jj = 1, nx
                        xb = xb + xstar(i,j,k,jj)*betaa(jj)
                    enddo
                
                    ur = 0.d0
                    do jj = 1, nu
                        ur = ur + ustar(i,j,k,jj)*rstar(i,jj)
                    enddo
                
                    ystar(k) = y(i,j,k) - xb - ur 
     +                       - theta(k)*(xi(i,j,k) - exi)
            
                enddo
                                        
                do k1 = 1, nk
                do k2 = 1, nk
                    qq(k1,k2) = qq(k1,k2) 
     +                        + lambda(i,j)
     +                          *ystar(k1)*ystar(k2)
                enddo
                enddo
        
            endif
            
        enddo

	  call gen_iwish(asigma, shape, qq, nk, iseed)            
  
	  do k1 = 1, nk
	      do k2 = 1, nk
	          sigma(j,k1,k2) = asigma(k1,k2)
	      enddo	      	      
	  enddo        

      enddo
            
      end subroutine     	
      
      
	subroutine gen_iwish(sigma,shape,qq,na,iseed)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 884, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 sigma(na,na), qq(na,na), shape
      
	real*8 qqinv(na,na)
	real*8 df, chi(na), anv(na,na), bb(na,na), suma
	real*8 tol, rsig(na,na), btemp(na,na), aainv(na,na)
            
	external drnchi, drnnof, dlinds, 
     +         dchfac, dmach, dmxytf, dmrrrr 
                  
      do j = 1, na
      
		df = shape - dfloat(j) + 1.d0
		
		call rnset(iseed)
		call drnchi(1, df, chi(j))
		call rnget(iseed)
		
		do i = 2, na
			call rnset(iseed)		
			anv(j,i) = drnnof()
			call rnget(iseed)
		enddo
		
	enddo

      bb(1,1) = chi(1)
      do j = 2, na

		suma = 0.0d0
		do i = 1, j-1         
			suma = suma + anv(i,j)**2
		enddo
		bb(j,j) = chi(j) + suma

		bb(1,j) = anv(1,j)*dsqrt(chi(1))
        bb(j,1) = bb(1,j)
        
        if (j .gt. 2) then
		    do i = 2, j-1         
			    suma = 0.0d0
			    do k = 1, i-1
				    suma = suma + anv(k,j)*anv(k,i)
			    enddo
			    bb(i,j) = anv(i,j)*dsqrt(chi(i)) + suma
		        bb(j,i) = bb(i,j)
		    enddo
	  endif
	  
	enddo
      
	call dlinds(na, qq, na, qqinv, na)	

	tol = 100.0d0*dmach(4)	
	call dchfac(na, qqinv, na, tol, irank, rsig, na)
	
      call dmxtyf(na,na,rsig,na,na,na,bb,na,na,na,btemp,na)
      call dmrrrr(na,na,btemp,na,na,na,rsig,na,na,na,aainv,na)
		
	call dlinds(na, aainv, na, sigma, na)	      
                                                        
      end subroutine      
      