	program main
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 590, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5
      integer, parameter :: niter1 = 10000, niter = 20000
      integer, parameter :: nniter = 100

      integer id
	real*8 bweight, bpd, mad, fl, ga
	real*8 smoke, sga, age, bmi
	real*8 x(nc), u(nr), tstar(3)

      integer imiss(ni,nj)
      real*8 y(ni,nj,nk)
      real*8 xstar(ni,nj,nk,nx), ustar(ni,nj,nk,nu)
      real*8 betaa(nx), rstar(ni,nu)
      real*8 theta(nk), xi(ni,nj,nk), exi
      real*8 lambda(ni,nj), sigma(nj,nk,nk)
      real*8 vv, omega(nu,nu)
      
      real*8 bw(ni), zstar(ni,nnc), uustar(nk,nu)
      real*8 gammaa(nnc), alpha(nk) 
      real*8 delta, ezeta, v1, api

      real*8 ppp(ni)
      real*8 pp(ni)
      real*8 rmse
      real*8 auc
      real*8 sensm(101)
      real*8 specm(101)

      real*8 mean_pp(ni)
      real*8 mean_rmse
      real*8 mean_auc
      real*8 mean_sensm(101)
      real*8 mean_specm(101)

      real*8 std_pp(ni)
      real*8 std_rmse
      real*8 std_auc
      real*8 std_sensm(101)
      real*8 std_specm(101)

      real*8 lower_pp(ni)
      real*8 lower_rmse
      real*8 lower_auc
      real*8 lower_sensm(101)
      real*8 lower_specm(101)

      real*8 upper_pp(ni)
      real*8 upper_rmse
      real*8 upper_auc
      real*8 upper_sensm(101)
      real*8 upper_specm(101)

      real*8 seq_pp(niter,ni)
      real*8 seq_rmse(niter)
      real*8 seq_auc(niter)
      real*8 seq_sensm(niter,101)
      real*8 seq_specm(niter,101)

      real*8 ahpd(niter), alow(2), aupp(2), aalpha
     
      common /vimiss/imiss
      common /vy/y
      common /vxstar/xstar
      common /vustar/ustar

      common /vbetaa/betaa
      common /vrstar/rstar
      common /vtheta/theta
      common /vxi/xi
      common /vexi/exi
      common /vlambda/lambda
      common /vsigma/sigma
      common /vvv/vv          
      common /vomega/omega     
      
      common /vbw/bw
      common /vzstar/zstar
      common /vuustar/uustar
      common /veta/eta
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vezeta/ezeta
      common /vv1/v1
      
      external gen_pp
                                
    	open(unit = 5, file = 'NewScan2.txt')
    	
    	open(unit = 11, file = 'PFetalGrowth_Output1.txt')
    	open(unit = 12, file = 'PFetalGrowth_Output2.txt')
    	open(unit = 13, file = 'PFetalGrowth_Output3.txt')
    	open(unit = 14, file = 'PFetalGrowth_Output4.txt')
    	open(unit = 15, file = 'PFetalGrowth_Output5.txt')
    	open(unit = 16, file = 'PFetalGrowth_Output6.txt')
    	open(unit = 17, file = 'PFetalGrowth_Output7.txt')

    	open(unit = 21, file = 'PFetalGrowth_Prediction1.txt')
    	open(unit = 22, file = 'PFetalGrowth_Prediction2.txt')
    	open(unit = 23, file = 'PFetalGrowth_Prediction3.txt')
            
      iseed = 9999999

      do i = 1, ni
        do j = 1, nj
            do k = 1, nk
                y(i,j,k) = -999.d0
                do l = 1, nx 
                    xstar(i,j,k,l) = -999.d0
                enddo
                do l = 1, nu
                    ustar(i,j,k,l) = -999.d0
                enddo                   
            enddo
        enddo
      enddo
                 	           	
      tstar(1) = 18.85714d0/40.14285714d0
      tstar(2) = 26.14286d0/40.14285714d0
      tstar(3) = 33.71429d0/40.14285714d0 

	do ii = 1, 2134
	
	  read(5,*) i, j, bweight,  
     +            bpd, mad, fl, ga, 
     +            smoke, sga, age, bmi

        smoke = (smoke - 6.786199d0)/7.152488d0
        sga = (sga - 0.2409502d0)/0.4279023d0
        age = (age - 28.32579d0)/4.255989d0
        bmi = (bmi - 21.5142d0)/3.170548d0
                             
        if (bweight .gt. 4000.d0) then
            bw(i) = 1.d0
        else
            bw(i) = 0.d0
        endif

        ga = ga/40.14285714d0
                       
        y(i,j,1) = bpd
        y(i,j,2) = mad
        y(i,j,3) = fl

        u(1) = 1.d0 
        u(2) = ga 
        u(3) = ga**2 
        u(4) = ga**3
        do jj = 1, 3
	      temp = ga - tstar(jj)
	      if (temp .lt. 0.d0) then
	          temp = 0.d0
	      endif
	      u(jj+4) = temp**3
	  enddo
                         
        do jj = 1, nr
            x(jj) = u(jj)
        enddo
        x(nr+1) = age   
        x(nr+2) = bmi
        x(nr+3) = sga 
        x(nr+4) = smoke 
                      
        do k = 1, nk
            
            do l = 1, nx 
                xstar(i,j,k,l) = 0.d0
            enddo
            do l = 1, nc
                xstar(i,j,k,nc*(k-1)+l) = x(l)
            enddo
                
            do l = 1, nu
                ustar(i,j,k,l) = 0.d0
            enddo                   
            do l = 1, nr
                ustar(i,j,k,nr*(k-1)+l) = u(l)
            enddo                                
      
        enddo      
                       
        zstar(i,1) = 1.d0 
        zstar(i,2) = age   
        zstar(i,3) = bmi
        zstar(i,4) = sga 
        zstar(i,5) = smoke 
        
        do k = 1, nk
        
            temp = 39.d0/40.14285714d0
                      
            u(1) = 1.d0
            u(2) = temp
            u(3) = temp**2
            u(4) = temp**3
            do jj = 1, 3
	          ttemp = temp - tstar(jj)
	          if (ttemp .lt. 0.d0) then
	              ttemp = 0.d0
	          endif
	          u(jj+4) = ttemp**3	          
	      enddo

            do l = 1, nu
                uustar(k,l) = 0.d0
            enddo
            do l = 1, nr
                uustar(k,nr*(k-1)+l) = u(l)
            enddo
                        
        enddo
       
	enddo    
			
	do i = 1, ni
	  do j = 1, nj
            imiss(i,j) = 1
            if (y(i,j,1) .lt. 0.d0) then
                imiss(i,j) = 0
            endif
        enddo
      enddo
      
c     set hyper-parameters

	api = dconst('pi')
	ezeta = dsqrt(2.d0/api) 
      exi = dsqrt(2.d0/api)
            
c     set initial values

      do i = 1, ni
        do j = 1, nj        
            rstar(i,j) = 0.d0    
            lambda(i,j) = 1.d0        
            do k = 1, nk        
		        xi(i,j,k) = exi
		    enddo
        enddo                        
      enddo
                                 
      call rnset(iseed)    

	do ir = 1, niter1
        read(11,*) irr, theta
        read(12,*) irr, betaa        
        read(13,*) irr, gammaa
        read(14,*) irr, alpha
        read(15,*) irr, delta, v1, vv
        read(16,*) irr, sigma
        read(17,*) irr, omega
        call gibbs(iseed)	
      enddo

      do i = 1, ni
	  mean_pp(i) = 0.d0
	  std_pp(i) = 0.d0
      enddo     

      mean_rmse = 0.d0
      std_rmse = 0.d0

	mean_auc = 0.d0
	std_auc = 0.d0

      do i = 1, 101
	  mean_sensm(i) = 0.d0
	  std_specm(i) = 0.d0
      enddo     

	do ir = 1, niter
        	                                          
        read(11,*) irr, theta
        read(12,*) irr, betaa        
        read(13,*) irr, gammaa
        read(14,*) irr, alpha
        read(15,*) irr, delta, v1, vv
        read(16,*) irr, sigma
        read(17,*) irr, omega
        
        do irr = 1, 20
            call gibbs(iseed)	
        enddo
        do i = 1, ni
            pp(i) = 0.d0
        enddo
        do irr = 1, nniter
            call gibbs(iseed)	
            call gen_pp(ppp)
            do i = 1, ni
                pp(i) = pp(i) + ppp(i)/dfloat(nniter)
            enddo
        enddo

        rmse = 0.d0      
        do i = 1, ni
            rmse = rmse + (bw(i) - pp(i))**2/dfloat(ni)
        enddo

        call gen_auc(bw, pp, auc, sensm, specm)


        do i = 1, ni
	      mean_pp(i) = mean_pp(i) + pp(i)/dfloat(niter)
	      std_pp(i) = std_pp(i) + pp(i)**2
	      seq_pp(ir,i) = pp(i)
        enddo     

        mean_rmse = mean_rmse + rmse/dfloat(niter)
        std_rmse = std_rmse + rmse**2
        seq_rmse(ir) = rmse

	  mean_auc = mean_auc + auc/dfloat(niter)
	  std_auc = std_auc + auc**2
	  seq_auc(ir) = auc

        do i = 1, 101
	      mean_sensm(i) = mean_sensm(i) + sensm(i)/dfloat(niter)
	      std_sensm(i) = std_sensm(i) + sensm(i)**2
	      seq_sensm(ir,i) = sensm(i)
	      
	      mean_specm(i) = mean_specm(i) + specm(i)/dfloat(niter)
	      std_specm(i) = std_specm(i) + specm(i)**2
	      seq_specm(ir,i) = specm(i)
        enddo     

      enddo

      call rnget(iseed)    


      do i = 1, ni
		temp = (std_pp(i) - dfloat(niter)*mean_pp(i)**2)
     +       / dfloat(niter-1)
		std_pp(i) = dsqrt(temp)     
      enddo     

	temp = (std_rmse - dfloat(niter)*mean_rmse**2)
     +     / dfloat(niter-1)
	std_rmse = dsqrt(temp)

	temp = (std_auc - dfloat(niter)*mean_auc**2)
     +     / dfloat(niter-1)
	std_auc = dsqrt(temp)

      do i = 1, 101

		temp = (std_sensm(i) - dfloat(niter)*mean_sensm(i)**2)
     +       / dfloat(niter-1)
		std_sensm(i) = dsqrt(temp)     

		temp = (std_specm(i) - dfloat(niter)*mean_specm(i)**2)
     +       / dfloat(niter-1)
		std_specm(i) = dsqrt(temp)     

      enddo     

      aalpha = 0.05d0
      do i = 1, ni
        do ir = 1, niter
            ahpd(ir) = seq_pp(ir,i)
        enddo
        call hpd(niter, aalpha, ahpd, alow, aupp)
        lower_pp(i) = alow(1); upper_pp(i) = aupp(1)
      enddo	

      aalpha = 0.05d0
      do ir = 1, niter
        ahpd(ir) = seq_rmse(ir)
      enddo
      call hpd(niter, aalpha, ahpd, alow, aupp)
      lower_rmse = alow(1); upper_rmse = aupp(1)

      aalpha = 0.05d0
      do ir = 1, niter
        ahpd(ir) = seq_auc(ir)
      enddo
      call hpd(niter, aalpha, ahpd, alow, aupp)
      lower_auc = alow(1); upper_auc = aupp(1)

      aalpha = 0.05d0
      do i = 1, 101
        do ir = 1, niter
            ahpd(ir) = seq_sensm(ir,i)
        enddo
        call hpd(niter, aalpha, ahpd, alow, aupp)
        lower_sensm(i) = alow(1); upper_sensm(i) = aupp(1)
      enddo	

      aalpha = 0.05d0
      do i = 1, 101
        do ir = 1, niter
            ahpd(ir) = seq_specm(ir,i)
        enddo
        call hpd(niter, aalpha, ahpd, alow, aupp)
        lower_specm(i) = alow(1); upper_specm(i) = aupp(1)
      enddo	

      do i = 1, ni
        write(21,2) i, mean_pp(i), std_pp(i), 
     +                 lower_pp(i), upper_pp(i)
      enddo

      write(22,2) 100, mean_rmse, std_rmse, 
     +                 lower_rmse, upper_rmse
      write(22,*)

      write(22,2) 100, mean_auc, std_auc, 
     +                 lower_auc, upper_auc

      do i = 1, 101
        write(23,2) i, mean_sensm(i), std_sensm(i), 
     +                 lower_sensm(i), upper_sensm(i),
     +                 mean_specm(i), std_specm(i), 
     +                 lower_specm(i), upper_specm(i)  
      enddo
      	
    1 format(i6, 1000f10.5)
    2 format(i6, 1000f20.10)

	end program


      subroutine gen_auc(bw, pp, auc, sensm, specm)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 590, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 bw(ni), pp(ni), auc, sensm(101), specm(101)

      integer icount0, icount1
      real*8 ck(100), sensk(100), speck(100)
      
      do k = 1, 100
        ck(k) = dfloat(k)/100.d0
      enddo

      do k = 1, 100
      
        sensk(k) = 0.d0 ; icount1 = 0 
        speck(k) = 0.d0 ; icount0 = 0  
        
        do i = 1, ni
        
            if (bw(i) .eq. 1.d0) then
            
                icount1 = icount1 + 1
                if (pp(i) .ge. ck(k)) then
                    sensk(k) = sensk(k) + 1.d0
                endif
                
            else
            
                icount0 = icount0 + 1
                if (pp(i) .lt. ck(k)) then
                    speck(k) = speck(k) + 1.d0
                endif
            
            endif
        
        enddo
        
        sensk(k) = sensk(k)/dfloat(icount1)
        speck(k) = speck(k)/dfloat(icount0)

      enddo
      
      sensm(1) = 1.d0
      specm(1) = 0.d0
      do k = 1, 100
        sensm(k+1) = sensk(k)
        specm(k+1) = speck(k)
      enddo
      
      auc = 0.d0
      do k = 2, 101
        auc = auc 
     +      + (sensm(k-1) + sensm(k))*(specm(k) - specm(k-1))
      enddo
      auc = auc/2.d0
                  
      end subroutine 


      subroutine gen_pp(pp)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 590, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 pp(ni)
      
      real*8 rstar(ni,nu)      
      real*8 zstar(ni,nnc), uustar(nk,nu)
      real*8 gammaa(nnc), alpha(nk) 
      real*8 delta, ezeta, v1         

	real*8 zg, ur, aub
      real*8 bound, errabs, errrel, errest, cdf

      common /vrstar/rstar                      
      common /vzstar/zstar
      common /vuustar/uustar
      common /vgammaa/gammaa
      common /valpha/alpha
      common /vdelta/delta
      common /vezeta/ezeta
      common /vv1/v1

      common /vzg/zg
      common /vaub/aub

      external df, dqdagi

      do i = 1, ni
            
        zg = 0.d0
        do j = 1, nnc
            zg = zg + zstar(i,j)*gammaa(j)
        enddo      

        aub = 0.d0
        do k = 1, nk
            ur = 0.d0
            do j = 1, nu
                ur = ur + uustar(k,j)*rstar(i,j)
            enddo
            aub = aub + alpha(k)*ur  
        enddo
        
	  errabs = 0.d0 ; errrel = 0.00001d0
	  bound = 0.d0 ; interv = 1
	  call dqdagi(df,bound,interv,errabs,errrel,cdf,errest)

        pp(i) = cdf
                    
      enddo      
                  
      end subroutine


      real*8 function df(zeta)
      implicit real*8 (a-h, o-z)
	integer, parameter :: ni = 590, nj = 4, nk = 3
	integer, parameter :: nr = 4+3, nc = nr+4
      integer, parameter :: nx = nk*nc, nu = nk*nr
      integer, parameter :: nnc = 5

      real*8 delta, ezeta, v1         
      real*8 zg, aub
      real*8 zeta, temp, tt, xx, api

      common /vdelta/delta
      common /vezeta/ezeta
      common /vv1/v1

      common /vzg/zg
      common /vaub/aub

	external dbetai

	api = dconst('pi')

      temp = zg + aub + delta*(zeta - ezeta)

      tt = dsqrt(v1)*temp
      xx = (tt + dsqrt(tt**2 + v1))/(2.d0*dsqrt(tt**2 + v1))
      df = dbetai(xx, v1/2.d0, v1/2.d0)
     +   * dexp(-zeta**2/2.d0)*dsqrt(2.d0/api)

      end function	          
       
	include 'PFetalGrowth_Gibbs.f'
	include 'tnorm.f'
	include 'optim1.f'
      include 'hpd.f'                        


